diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fat16filesystem.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fat16filesystem.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fat16filesystem.cpp	2010-05-18 19:32:31.856848559 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fat16filesystem.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -21,7 +21,7 @@
 */
 
 #include"fat16filesystem.h"
-
+#include <cstring>
 
 /**
 Initializes the boot sector of a FAT 16 volume
@@ -76,45 +76,45 @@
 	//copying of boot sector values in to the array
 	iData = new unsigned char[BytesPerSector];
 	unsigned int pos = 0;
-	memcpy(&iData[pos],JmpBoot,3);
+	memmove(&iData[pos],JmpBoot,3);
 	pos += 3;
-	memcpy(&iData[pos],OEMName,8);
+	memmove(&iData[pos],OEMName,8);
 	pos += 8;
-	memcpy(&iData[pos],&BytesPerSector,2);
+	memmove(&iData[pos],&BytesPerSector,2);
 	pos += 2;
-	memcpy(&iData[pos],&SectorsPerCluster,1);
+	memmove(&iData[pos],&SectorsPerCluster,1);
 	pos += 1;
-	memcpy(&iData[pos],&ReservedSectors,2);
+	memmove(&iData[pos],&ReservedSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&NumFats,1);
+	memmove(&iData[pos],&NumFats,1);
 	pos += 1;
-	memcpy(&iData[pos],&RootDirEntries,2);
+	memmove(&iData[pos],&RootDirEntries,2);
 	pos += 2;
-	memcpy(&iData[pos],&LowSectors,2);
+	memmove(&iData[pos],&LowSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&Media,1);
+	memmove(&iData[pos],&Media,1);
 	pos += 1;
-	memcpy(&iData[pos],&FatSectors,2);
+	memmove(&iData[pos],&FatSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&SectorPerTrack,2);
+	memmove(&iData[pos],&SectorPerTrack,2);
 	pos += 2;
-	memcpy(&iData[pos],&NumberOfHeads,2);
+	memmove(&iData[pos],&NumberOfHeads,2);
 	pos += 2;
-	memcpy(&iData[pos],&HiddenSectors,4);
+	memmove(&iData[pos],&HiddenSectors,4);
 	pos += 4;
-	memcpy(&iData[pos],&HighSectorsCount,4);
+	memmove(&iData[pos],&HighSectorsCount,4);
 	pos += 4;
-	memcpy(&iData[pos],&BootSectorDriveNumber,1);		
+	memmove(&iData[pos],&BootSectorDriveNumber,1);		
 	pos += 1;
-	memcpy(&iData[pos],&ReservedByte,1);
+	memmove(&iData[pos],&ReservedByte,1);
 	pos += 1;
-	memcpy(&iData[pos],&BootSignature,1);
+	memmove(&iData[pos],&BootSignature,1);
 	pos += 1;
-	memcpy(&iData[pos],&VolumeId,4);
+	memmove(&iData[pos],&VolumeId,4);
 	pos += 4;
-	memcpy(&iData[pos],VolumeLab,11);
+	memmove(&iData[pos],VolumeLab,11);
 	pos += 11;
-	memcpy(&iData[pos],FileSysType,8);
+	memmove(&iData[pos],FileSysType,8);
 	pos += 8;
 	while(pos < BytesPerSector)
 	{
@@ -133,7 +133,7 @@
 	ComputeClusterSizeInBytes();
 	ComputeRootDirSectors();
 	ComputeBytesPerSector();
-	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORCREATEMSG, "FAT16");
+	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORCREATEMSG,"FAT16");
 }
 
 /**
@@ -195,8 +195,8 @@
 		// Each FAT16 entries occupies 2 bytes, hence multiply by 2
 		aFatString.append((totalFatEntries - clusterCounter)*2, 0);
 	}
-	MessageHandler::ReportMessage (INFORMATION,FATTABLEWRITEMSG,
-								   "FAT16");
+
+	MessageHandler::ReportMessage (INFORMATION,FATTABLEWRITEMSG,"FAT16");
 	
 	// Write FAT table multiple times depending upon the No of FATS set.
 	unsigned int noOfFats = iFAT16BootSector.NumberOfFats();
@@ -313,6 +313,6 @@
 	catch(...)
 	{
 		delete dirRegionPtr;
-		throw ErrorHandler(UNKNOWNERROR, __FILE__, __LINE__);
+		throw ErrorHandler(UNKNOWNERROR,__FILE__,__LINE__);
 	}
 }
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fat32bootsector.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fat32bootsector.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fat32bootsector.cpp	2010-05-18 19:32:31.856848559 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fat32bootsector.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -21,6 +21,7 @@
 */
 
 #include "fat32bootsector.h"
+#include <cstring>
 
 /**
 Constructor of the fat16 boot sector class
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fat32filesystem.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fat32filesystem.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fat32filesystem.cpp	2010-05-18 19:32:31.856848559 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fat32filesystem.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -21,6 +21,7 @@
 */
 
 #include"fat32filesystem.h"
+#include <cstring>
 
 /**
 Initializes the boot sector of a FAT 32 volume
@@ -90,59 +91,59 @@
 	//copying of boot sector values in to the array
 	iData = new unsigned char[BytesPerSector];
 	unsigned int pos = 0;
-	memcpy(&iData[pos],JmpBoot,3);
+	memmove(&iData[pos],JmpBoot,3);
 	pos += 3;
-	memcpy(&iData[pos],OEMName,8);
+	memmove(&iData[pos],OEMName,8);
 	pos += 8;
-	memcpy(&iData[pos],&BytesPerSector,2);
+	memmove(&iData[pos],&BytesPerSector,2);
 	pos += 2;
-	memcpy(&iData[pos],&SectorsPerCluster,1);
+	memmove(&iData[pos],&SectorsPerCluster,1);
 	pos += 1;
-	memcpy(&iData[pos],&ReservedSectors,2);
+	memmove(&iData[pos],&ReservedSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&NumFats,1);
+	memmove(&iData[pos],&NumFats,1);
 	pos += 1;
-	memcpy(&iData[pos],&RootDirEntries,2);
+	memmove(&iData[pos],&RootDirEntries,2);
 	pos += 2;
-	memcpy(&iData[pos],&LowSectors,2);
+	memmove(&iData[pos],&LowSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&Media,1);
+	memmove(&iData[pos],&Media,1);
 	pos += 1;
-	memcpy(&iData[pos],&FatSectors,2);
+	memmove(&iData[pos],&FatSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&SectorPerTrack,2);
+	memmove(&iData[pos],&SectorPerTrack,2);
 	pos += 2;
-	memcpy(&iData[pos],&NumberOfHeads,2);
+	memmove(&iData[pos],&NumberOfHeads,2);
 	pos += 2;
-	memcpy(&iData[pos],&HiddenSectors,4);
+	memmove(&iData[pos],&HiddenSectors,4);
 	pos += 4;
-	memcpy(&iData[pos],&HighSectorsCount,4);
+	memmove(&iData[pos],&HighSectorsCount,4);
 	pos += 4;
-	memcpy(&iData[pos],&FatSectors32,4);
+	memmove(&iData[pos],&FatSectors32,4);
 	pos += 4;
-	memcpy(&iData[pos],&ExtFlags,2);
+	memmove(&iData[pos],&ExtFlags,2);
 	pos += 2;
-	memcpy(&iData[pos],&FileSystemVersion,2);
+	memmove(&iData[pos],&FileSystemVersion,2);
 	pos += 2;
-	memcpy(&iData[pos],&RootCluster,4);
+	memmove(&iData[pos],&RootCluster,4);
 	pos += 4;
-	memcpy(&iData[pos],&FSInfo,2);
+	memmove(&iData[pos],&FSInfo,2);
 	pos += 2;
-	memcpy(&iData[pos],&BackUpBootSector,2);
+	memmove(&iData[pos],&BackUpBootSector,2);
 	pos += 2;
-	memcpy(&iData[pos],FutureReserved,12);
+	memmove(&iData[pos],FutureReserved,12);
 	pos += 12;
-	memcpy(&iData[pos],&BootSectorDriveNumber,1);
+	memmove(&iData[pos],&BootSectorDriveNumber,1);
 	pos += 1;
-	memcpy(&iData[pos],&ReservedByte,1);
+	memmove(&iData[pos],&ReservedByte,1);
 	pos += 1;
-	memcpy(&iData[pos],&BootSignature,1);
+	memmove(&iData[pos],&BootSignature,1);
 	pos += 1;
-	memcpy(&iData[pos],&VolumeId,4);
+	memmove(&iData[pos],&VolumeId,4);
 	pos += 4;
-	memcpy(&iData[pos],VolumeLab,11);
+	memmove(&iData[pos],VolumeLab,11);
 	pos += 11;
-	memcpy(&iData[pos],FileSystemType,8);
+	memmove(&iData[pos],FileSystemType,8);
 	pos += 8;
 	while(pos < BytesPerSector)
 	{
@@ -159,7 +160,7 @@
 	ComputeClusterSizeInBytes();
 	ComputeRootDirSectors();
 	ComputeBytesPerSector();
-	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORCREATEMSG, "FAT32");
+	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORCREATEMSG,"FAT32");
 }
 
 /**
@@ -172,7 +173,7 @@
 */
 void CFat32FileSystem::WriteBootSector(ofstream& aOutPutStream)
 {
-	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORWRITEMSG, "FAT32");
+	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORWRITEMSG,"FAT32");
 	aOutPutStream.write(reinterpret_cast<char*>(&iData[0]),iFAT32BootSector.BytesPerSector());
 	aOutPutStream.flush();
 }
@@ -228,8 +229,9 @@
 		// Each FAT32 entries occupies 4 bytes, hence multiply by 4
 		aFatString.append((totalFatEntries - clusterCounter)*4, 0);
 	}
-	MessageHandler::ReportMessage (INFORMATION,FATTABLEWRITEMSG,
-								   "FAT32");
+
+	MessageHandler::ReportMessage (INFORMATION,FATTABLEWRITEMSG,"FAT32");
+
 	//Write FAT table multiple times depending on the value of No of FATS set.
 	unsigned int noOfFats = iFAT32BootSector.NumberOfFats();
 	for(unsigned int i=0; i<noOfFats; i++)
@@ -254,19 +256,19 @@
 	unsigned int bytesPerSector = iFAT32BootSector.BytesPerSector();
 	FSinfoData = new unsigned char[bytesPerSector];
 	iFSInfo.SetFSInfo();
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_LeadSign,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_LeadSign,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Reserved,480);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Reserved,480);
 	counter += 480;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_StrucSig,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_StrucSig,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Free_Count,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Free_Count,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Nxt_Free,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Nxt_Free,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Reserved2,12);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Reserved2,12);
 	counter += 12;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_TrailSig,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_TrailSig,4);
 	counter += 4;
 	counter += (bytesPerSector-KSizeOfFatBootSector);
 	aOutPutStream.write(reinterpret_cast<char*>(&FSinfoData[0]),counter);
@@ -367,11 +369,11 @@
  	iTotalClusters = totalDataSectors / iFAT32BootSector.SectorsPerCluster();
 	if(iTotalClusters < KMinimumFat32Clusters)
 	{
-		throw ErrorHandler(BOOTSECTORERROR,"Low Partition Size",__FILE__, __LINE__);
+		throw ErrorHandler(BOOTSECTORERROR,"Low Partition Size",__FILE__,__LINE__);
 	}
 	else if(iTotalClusters > KMaximumFat32Clusters)
 	{
-		throw ErrorHandler(BOOTSECTORERROR,"high Partition Size",__FILE__, __LINE__);
+		throw ErrorHandler(BOOTSECTORERROR,"high Partition Size",__FILE__,__LINE__);
 	}
 }
 /**
@@ -424,7 +426,7 @@
 	{
 		delete dirRegionPtr;
 		dirRegionPtr = NULL;
-		throw ErrorHandler(UNKNOWNERROR, __FILE__, __LINE__);
+		throw ErrorHandler(UNKNOWNERROR,__FILE__,__LINE__);
 	}
 }
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp	2010-05-18 19:32:31.856848559 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -22,6 +22,7 @@
 */
 
 #include "fatbasebootsector.h"
+#include <cstring>
 
 /**
 Constructor of the base boot sector class
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/longname.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/longname.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/longname.cpp	2010-05-18 19:32:31.856848559 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/longname.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -21,6 +21,7 @@
 
 
 #include "longname.h"
+#include <cstring>
 
 
 /** 
@@ -48,7 +49,7 @@
 	iLongNameLength = iLongName.length();
 	if(iLongNameLength == 0)
 	{
-		throw ErrorHandler(EMPTYFILENAME, __FILE__, __LINE__);
+		throw ErrorHandler(EMPTYFILENAME,__FILE__,__LINE__);
 	}
 	FormatLongFileName(iLongName);
 	iShortName = GetShortEntryName();
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/messagehandler.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/messagehandler.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/messagehandler.cpp	2010-05-18 19:32:31.860849207 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/messagehandler.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -51,7 +51,7 @@
 @param aFileName
 Name of the Log File
 */
-void MessageHandler::StartLogging(char *aFileName)
+void MessageHandler::StartLogging(char const *aFileName)
 {
     GetInstance()->StartLogging(aFileName);
 }
@@ -74,7 +74,7 @@
 @internalComponent
 @released
 */
-void MessageHandler::ReportMessage(int aMsgType, int aMsgIndex,char* aName)
+void MessageHandler::ReportMessage(int aMsgType, int aMsgIndex,char const* aName)
 {
 	GetInstance()->ReportMessage(aMsgType,aMsgIndex,aName);
 }
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/messageimplementation.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/messageimplementation.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/filesystem/source/messageimplementation.cpp	2010-05-18 19:32:31.860849207 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/filesystem/source/messageimplementation.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -23,15 +23,17 @@
 
 #include "messageimplementation.h"
 #include "errorhandler.h"
+#include <cstring>
 
 using std::endl;
 using std::cout;
 typedef std::string String;
 
-char *errorMssgPrefix="FileSystem : Error:";
-char *warnMssgPrefix="FileSystem : Warning:";
-char *infoMssgPrefix="FileSystem : Information:";
-char *Space=" ";
+char const *errorMssgPrefix="FileSystem : Error:";
+char const *warnMssgPrefix="FileSystem : Warning:";
+char const *infoMssgPrefix="FileSystem : Information:";
+char const *Space=" ";
+
 
 enum MessageArraySize{MAX=16};
 
@@ -202,7 +204,7 @@
 
 @param aFileName - Name of the Log file
 */
-void MessageImplementation::StartLogging(char *aFileName)
+void MessageImplementation::StartLogging(char const *aFileName)
 {
 	char logFile[1024];
 	FILE *fptr;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/host/h_utl.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/host/h_utl.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/host/h_utl.cpp	2010-05-18 19:32:31.860849207 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/host/h_utl.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -177,7 +177,7 @@
 
 
 	TInt build=0;
-	memset(&aVersion, sizeof(TVersion), 0);	
+	memset(&aVersion, 0, sizeof(TVersion));
 	TInt i;
 	TInt len=strlen(str);
 	for (i=0; i<len; i++)
@@ -192,7 +192,7 @@
 		{ 
 		cout << "\n Warning: major version must be in range 0 - 127 \n";
 		}
-	char* pMinor = strchr(str, '.');
+	char const * pMinor = strchr(str, '.');
 	if (pMinor)
 		{
 		pMinor++; 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/inc/h_utl.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/inc/h_utl.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/inc/h_utl.h	2010-05-18 19:32:31.860849207 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/inc/h_utl.h	2010-05-15 14:32:45.000000000 +0100
@@ -65,9 +65,6 @@
 #define _stricmp strcasecmp		
 #define strnicmp strncasecmp	
 
-// to fix the linux problem: memcpy does not work with overlapped areas.
-#define memcpy memmove
-
 // hand-rolled strupr function for converting a string to all uppercase
 char* strupr(char *a);
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp	2010-05-18 19:32:31.864848459 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -21,6 +21,7 @@
 
 
 #include "parameterfileprocessor.h"
+#include <cstring>
 
 
 /**
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/group/BLD.INF /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/group/BLD.INF
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/group/BLD.INF	2010-05-18 19:32:31.868848898 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/group/BLD.INF	2010-05-15 14:32:45.000000000 +0100
@@ -15,13 +15,14 @@
 *
 */
 
+#include <productvariant.hrh>
 
 PRJ_PLATFORMS
 TOOLS2
 
 PRJ_EXPORTS
 
-../maksym/fixupsym.bat              /epoc32/tools/fixupsym.bat
+../maksym/fixupsym.bat              EPOCROOT_EXPORT_PATH(epoc32/tools/fixupsym.bat)
 ../maksym/hpsym.bat                 /epoc32/tools/hpsym.bat
 ../maksym/maksym.bat                /epoc32/tools/maksym.bat
 ../maksym/maksymrofs.bat            /epoc32/tools/maksymrofs.bat
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/group/readimage.mmp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/group/readimage.mmp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/group/readimage.mmp	2010-05-18 19:32:31.868848898 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/group/readimage.mmp	2010-05-15 14:32:45.000000000 +0100
@@ -45,15 +45,16 @@
 userinclude     ..\..\imglib\compress 
 userinclude		..\..\imglib\patchdataprocessor\include
 userinclude		..\..\sisutils\inc
+#ifndef TOOLS2_LINUX
 userinclude   ..\..\imglib\boostlibrary
+#endif
 
 USERINCLUDE ..\..\imglib\inc
 OS_LAYER_SYSTEMINCLUDE_SYMBIAN
 
 staticlibrary 	sisutils
 #ifdef TOOLS2_LINUX
-STATICLIBRARY   boost_thread-mgw34-mt-1_39_linux
-OPTION    GCC -pthread -O2 -Wno-uninitialized
+OPTION    GCC -pthread -O2 -Wno-uninitialized -lboost_thread-mt
 #else
 STATICLIBRARY   boost_thread-mgw34-mt-1_39_win32
 OPTION    GCC -mthreads -O2 -Wno-uninitialized
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/inc/common.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/inc/common.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/inc/common.h	2010-05-18 19:32:31.872848917 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/inc/common.h	2010-05-15 14:32:45.000000000 +0100
@@ -46,7 +46,7 @@
 #define DLL_UID1	10000079
 #define EXE_UID1	1000007a
 
-typedef enum EImageType
+enum EImageType
 {
 	EUNKNOWN_IMAGE,
 	EROM_IMAGE,
@@ -98,7 +98,7 @@
 	void Report();
 };
 
-ostream& DumpInHex(char* aDesc, TUint32 aData, bool aContinue = false,TUint aDataWidth=8,\
-				   char aFiller='0', TUint aMaxDescWidth=28);
+ostream& DumpInHex(char const * aDesc, TUint32 aData, bool aContinue = false,
+			TUint aDataWidth=8, char aFiller='0', TUint aMaxDescWidth=28);
 
 #endif //__IMAGE_READER_COMMON_H_
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/inc/image_reader.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/inc/image_reader.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/inc/image_reader.h	2010-05-18 19:32:31.872848917 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/inc/image_reader.h	2010-05-15 14:32:45.000000000 +0100
@@ -27,7 +27,19 @@
 
 
 #include "common.h"
-#include <direct.h>
+#if defined(WIN32)
+	#include <direct.h>
+	#define GETCWD	_getcwd
+	#define CHDIR	_chdir
+	#define MKDIR(dir)	_mkdir(dir)
+#elif defined(__LINUX__)
+	#include <sys/stat.h>
+	#include <unistd.h>
+	#define GETCWD	getcwd
+	#define CHDIR	chdir
+	#define MKDIR(dir)	mkdir((dir),S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH)
+#endif
+
 #include <map>
 
 typedef struct tag_FILEINFO
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/inc/rofs_image_reader.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/inc/rofs_image_reader.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/inc/rofs_image_reader.h	2010-05-18 19:32:31.872848917 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/inc/rofs_image_reader.h	2010-05-15 14:32:45.000000000 +0100
@@ -65,10 +65,10 @@
 	void DumpDirStructure();
 	void DumpFileAttributes();
 	void MarkNodes();
-	void SetSeek(streampos aOff, ios::seek_dir aStartPos=ios::beg);
+	void SetSeek(streampos aOff, std::ios_base::seekdir aStartPos);
 	void ExtractImageContents();
 	void CheckFileExtension(char* aFileName,TRomBuilderEntry* aEntry,TRomNode* aNode,ofstream& aLogFile );
-	void GetCompleteNodePath(TRomNode* aNode,string& aName,char* aAppStr);
+	void GetCompleteNodePath(TRomNode* aNode,string& aName,char const* aAppStr);
 	void WriteEntryToFile(char* aFileName,TRomNode* aNode,ofstream& aLogFile);
 
 	void GetFileInfo(FILEINFOMAP &aFileMap);
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/common.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/common.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/common.cpp	2010-05-18 19:32:31.872848917 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/common.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -40,7 +40,7 @@
 	*out << "Usage Error:" << iErrMessage.c_str() << endl;
 }
 
-ostream& DumpInHex(char* aDesc, TUint32 aData, bool aContinue, TUint aDataWidth, \
+ostream& DumpInHex(char const* aDesc, TUint32 aData, bool aContinue, TUint aDataWidth, \
 				   char aFiller, TUint aMaxDescWidth)
 {
 	TUint aDescLen = strlen(aDesc);
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/image_reader.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/image_reader.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -173,7 +173,7 @@
 
 
 	// get the current working directory and store in buffer.
-	if( _getcwd(currWorkingDir,_MAX_BUFFER_SIZE_) == NULL )
+	if( GETCWD(currWorkingDir,_MAX_BUFFER_SIZE_) == NULL )
 	{
 		// throw an exception if unable to get current working directory information.
 		throw ImageReaderException((char*)ImageReader::iImgFileName.c_str(), "Failed to get the current working directory");
@@ -191,7 +191,7 @@
 			changeToDrive.append(aDelimiter);
 			
 			// change the current working directory to the specified directory.
-			if( _chdir(changeToDrive.c_str()) )
+			if( CHDIR(changeToDrive.c_str()) )
 			{
 				// throw an exception if unable to change the directory specified.
 				throw ImageReaderException((char*)ImageReader::iImgFileName.c_str(), "Failed to change to the directory specified");
@@ -200,23 +200,23 @@
 		else
 		{
 			// if not,then create a cPtr directory. 
-			_mkdir(cPtr);
+			MKDIR(cPtr);
 			// change the current working directory to cPtr.
-			_chdir(cPtr);
+			int r = CHDIR(cPtr); (void)r;
 		}
 		// repeat till cPtr is NULL.
 		while (cPtr!=NULL)
 		{
-			if (cPtr = strtok(NULL,aDelimiter))
+			if ((cPtr = strtok(NULL,aDelimiter)) != NULL)
 			{
 				// create the directory.
-				_mkdir(cPtr);
+				MKDIR(cPtr);
 				// change current working directory.
-				_chdir(cPtr);
+				int r = CHDIR(cPtr); (void)r;
 			}
 		}
 		// revert back the working directory.
-		_chdir(currWorkingDir);
+		int r = CHDIR(currWorkingDir); (void)r;
 		// replace the source path with the original path information.
 		strcpy(aSrcPath,origPath.c_str());
 		delete[] currWorkingDir;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/rofs_image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/rofs_image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/rofs_image_reader.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/rofs_image_reader.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -42,7 +42,7 @@
 	delete iImageReader;
 }
 
-void RofsImageReader::SetSeek(streampos aOff, ios::seek_dir aStartPos)
+void RofsImageReader::SetSeek(streampos aOff, std::ios_base::seekdir aStartPos)
 {
 	if(!iInputFile)
 		return;
@@ -417,7 +417,8 @@
 	{
 		// get the complete path 
 		path.assign( (char*)aNode->iName );
-		GetCompleteNodePath( aNode, path, "\\\\" );
+		GetCompleteNodePath( aNode, path,"\\\\");
+
 	}
 	else
 	{
@@ -462,7 +463,7 @@
 @param aAppStr	- string to append.
 @return - returns full path of the given file.
 */
-void RofsImageReader::GetCompleteNodePath(TRomNode* aNode,string& aName,char* aAppStr)
+void RofsImageReader::GetCompleteNodePath(TRomNode* aNode,string& aName, char const* aAppStr)
 {
 	// check if the entry has a parent.
 	TRomNode* NodeParent = aNode->GetParent();
@@ -496,7 +497,7 @@
 	{
 		// get the complete path 
 		path.assign( (char*)aNode->iName );
-		GetCompleteNodePath( aNode, path, "\\" );
+		GetCompleteNodePath( aNode, path,"\\");
 	}
 	else
 	{
@@ -549,7 +550,7 @@
 				{
 					// get the complete path 
 					fileName.assign( (char*)currNode->iName );
-					GetCompleteNodePath( currNode, fileName, (char*)DIR_SEPARATOR );
+					GetCompleteNodePath( currNode, fileName,DIR_SEPARATOR );
 				}
 			}
 			else
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/rom_image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/rom_image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/readimage/src/rom_image_reader.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/readimage/src/rom_image_reader.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -20,6 +20,12 @@
 #include <e32rom.h>
 #include "rom_image_reader.h"
 #include "r_rom.h"
+#if defined(WIN32)
+	#define ALLOCA _alloca
+#elif defined(__LINUX__)
+	#include <alloca.h>
+	#define ALLOCA alloca
+#endif
 
 void InflateUnCompress(unsigned char* source, int sourcesize, unsigned char* dest, int destsize);
 RomImageFSEntry::RomImageFSEntry (const char* aName) : iName(aName), iSibling(0), iChildren(0) {
@@ -495,7 +502,7 @@
 
 void RomImageReader::Name(string& aName, const wchar_t* aUnicodeName, TUint aLen)
 {
-	char* temp = (char*)_alloca((aLen << 1) + 1) ;
+	char* temp = (char*)ALLOCA((aLen << 1) + 1) ;
 	size_t n = wcsrtombs(temp,&aUnicodeName,aLen,NULL);
 	if(n == (size_t)-1){ // the unicode string can not be coverted.
 		aName = "???";
@@ -695,8 +702,8 @@
 	*out << left << prefix;
 	out->width(40);	
 	*out << right << file->Name() << "[" ;
-	DumpInHex( "", aRomImgEntry->iHardwareVariant, true) << "] ";
-	DumpInHex( " DataSize=", (aRomImgEntry->iBssSize + aRomImgEntry->iDataSize), true) << endl;
+	DumpInHex("", aRomImgEntry->iHardwareVariant, true) << "] ";
+	DumpInHex(" DataSize=", (aRomImgEntry->iBssSize + aRomImgEntry->iDataSize), true) << endl;
 	
 }
 
